<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" class="!w-50%">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="150px"
      v-loading="formLoading"
      :validate-on-rule-change="false"
    >
      <el-form-item label="候选人名称" prop="votingActivityJoinItemTitle">
        <el-input v-model="formData.votingActivityJoinItemTitle" placeholder="请输入候选人名称" class="!w-240px"/>
      </el-form-item>
			<el-form-item label="候选人类型" prop="votingActivityJoinItemCategory">
				<el-select
					v-model="formData.votingActivityJoinItemCategory"
					filterable
					allow-create
					default-first-option
					:reserve-keyword="false"
					class="!w-240px"
					placeholder="请输入候选人类型"
				>
					<el-option v-for="(item, index) in candidate" :key="index" :label="item" :value="item" />
				</el-select>
      </el-form-item>
			<el-form-item label="候选人封面图" prop="headImg">
        <UploadImg v-model="formData.headImg" height="150px" width="150px" :fileSize="20" />
      </el-form-item>
			<el-form-item label="候选人轮播图" prop="votingActivityJoinItemContent.banners">
        <UploadImgs v-model="formData.votingActivityJoinItemContent.banners" />
      </el-form-item>
      <el-form-item label="候选人介绍" prop="votingActivityJoinItemContent.content">
        <Editor v-model="formData.votingActivityJoinItemContent.content" height="150px" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script setup lang="ts">
import { VotingActivityApi } from '@/api/menduner/system/vote'

defineOptions({ name: 'VotingActivityJoinItemForm' })
defineProps({
  area: Array,
  position: Array,
	candidate: Array
})
const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
	votingActivityJoinItemId: undefined,
	votingActivityId: undefined as number | undefined,
	votingActivityJoinItemTitle: undefined,
	votingActivityJoinItemCategory: undefined,
	votingActivityJoinItemContent: {
		banners: [],
		content: undefined,
		video: undefined
	},
	headImg: undefined
})

const formRules = reactive({
  votingActivityJoinItemTitle: [{ required: true, message: '候选人名称不能为空', trigger: 'blur' }],
  votingActivityJoinItemCategory: [{ required: true, message: '候选人类型不能为空', trigger: 'change' }],
  headImg: [{ required: true, message: '候选人封面图不能为空', trigger: 'change' }],
	'votingActivityJoinItemContent.banners': [{ required: true, message: '候选人轮播图不能为空', trigger: 'change' }],
	'votingActivityJoinItemContent.content': [{ required: true, message: '候选人介绍不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, votingActivityId: number, votingActivityJoinItemId?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
	formData.value.votingActivityId = votingActivityId
  // 修改时，设置数据
  if (votingActivityJoinItemId) {
    formLoading.value = true
    try {
      formData.value = await VotingActivityApi.getVotingActivityJoinItem(votingActivityJoinItemId)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    if (formType.value === 'create') {
      await VotingActivityApi.createVotingActivityJoinItem(formData.value)
      message.success(t('common.createSuccess'))
    } else {
      await VotingActivityApi.updateVotingActivityJoinItem(formData.value)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
		votingActivityJoinItemId: undefined,
		votingActivityId: undefined,
		votingActivityJoinItemTitle: undefined,
		votingActivityJoinItemCategory: undefined,
		votingActivityJoinItemContent: {
			banners: [],
			content: undefined,
			video: undefined
		},
		headImg: undefined
	}
  formRef.value?.resetFields()
}
</script>